/**
 * @author Rafael Ostertag <rafael.ostertag@math.uzh.ch>
 */
/* global describe */
/* global it */
/* global expect */
/* global QfqNS */
/* global beforeAll */
/* global beforeEach */
/* global jasmine */
/* global $ */

describe("Element Checkbox", function () {
    'use strict';

    var reminderCheckbox, checkbox2;
    var $reminderCheckbox, $checkbox2;

    beforeAll(function () {
        $reminderCheckbox = $('input[name=reminder]');
        $checkbox2 = $('input[name=checkbox2]');
        reminderCheckbox = new QfqNS.Element.Checkbox($reminderCheckbox);
        checkbox2 = new QfqNS.Element.Checkbox($checkbox2);
    });

    beforeEach(function () {
        $('#myForm')[0].reset();
    });

    it('should get the initial checked value', function () {
        expect(reminderCheckbox.getValue()).toBe(false);
        expect(checkbox2.getValue()).toBe(true);
    });

    it('should reflect dynamically changed values', function () {
        $reminderCheckbox.prop('checked', true);
        $checkbox2.prop('checked', false);

        expect(reminderCheckbox.getValue()).toBe(true);
        expect(checkbox2.getValue()).toBe(false);
    });

    it('should set value properly', function () {
        reminderCheckbox.setValue(true);
        checkbox2.setValue(false);

        expect($reminderCheckbox.prop('checked')).toBe(true);
        expect($checkbox2.prop('checked')).toBe(false);
    });
});